Index: trunk/src/lib/graphics/importer/model.h
===================================================================
--- trunk/src/lib/graphics/importer/model.h	(revision 6012)
+++ trunk/src/lib/graphics/importer/model.h	(revision 6022)
@@ -1,199 +1,163 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+
 /*!
-  \file model.h
-  \brief Contains the Model Class that handles 3D-Models
-*/
+ * @file model.h
+ *  Definition of an abstract model.
+ *  containing all needed for other models
+ */
 
 #ifndef _MODEL_H
 #define _MODEL_H
 
-#include "abstract_model.h"
+#include "base_object.h"
+#include "vector.h"
 
-#include "material.h"
-#include "glincl.h"
-#include "array.h"
-#include <list>
-
-// FORWARD DECLARATION //
-template<class T> class tArray;
+using namespace std;
 
 
-//! an enumerator fot the different Model Types.
-/**
-   MODEL_DISPLAY_LIST means, that a DisplayList will be built out of the model. This model will be STATIC, meaning it cannot be changed after initialisation.
-   MODEL_VERTEX_ARRAY means, that a VertexArray will be built out of the model. This moel will be DYNAMIX, meaning that one can change the properties from outside of the model.
- * @todo implement this stuff
-*/
-typedef enum MODEL_TYPE {
-  MODEL_DISPLAY_LIST,
-  MODEL_VERTEX_ARRAY
+
+//! compressed vertex data: char insetead of float, the value will be expanded by the scale value. only for loading
+typedef struct
+{
+  char             v[3];                 //!< the vector of the vertex
+  unsigned char    lightNormalIndex;     //!< the index of the light normal
+} sVertex;
+
+
+//! compressed texture offset data: coords scaled by the texture size. Only for loading
+typedef struct
+{
+  short            s;                    //!< the s,t coordinates of a texture
+  short            t;                    //!< the s,t coordinates of a texture
+} sTexCoor;
+
+
+//! holds tha informations about a md2 frame
+typedef struct
+{
+  sVec3D           scale;                //!< scales values of the model
+  sVec3D           translate;            //!< translates the model
+  char             name[16];             //!< frame name: something like "run32"
+  sVertex          pVertices[1];         //!< first vertex of thes frame
+} sFrame;
+
+
+//! holds the information about a triangle
+typedef struct
+{
+  unsigned short   indexToVertices[3];   //!< index to the verteces of the triangle
+  unsigned short   indexToTexCoor[3];    //!< index to the texture coordinates
+} sTriangle;
+
+
+//! holds the information about a triangle
+typedef struct
+{
+  unsigned int   indexToVertices[3];   //!< index to the verteces of the triangle
+  unsigned int   indexToNormals[3];    //!< index to the normals of the triangle
+  unsigned int   indexToTexCoor[3];    //!< index to the texture coordinates
+} sTriangleExt;
+
+
+//! the command list of the md2 model, very md2 specific
+typedef struct
+{
+  float            s;                    //!< texture coordinate 1
+  float            t;                    //!< texture coordinate 2
+  int              vertexIndex;          //!< index of the vertex in the vertex list
+} glCommandVertex;
+
+
+//! a md2 animation definition
+typedef struct
+{
+  int              firstFrame;           //!< first frame of the animation
+  int              lastFrame;            //!< last frame of the animation
+  int              fps;                  //!< speed: number of frames per second
+} sAnim;
+
+
+//! animation state definition
+typedef struct
+{
+  int              startFrame;           //!< the start frame of an animation
+  int              endFrame;             //!< last frame of the animation
+  int              fps;                  //!< fps of the animaion (speed)
+
+  float            localTime;            //!< the local time
+  float            lastTime;             //!< last time stamp
+  float            interpolationState;   //!< the state of the animation [0..1]
+
+  int              type;                 //!< animation type
+
+  int              currentFrame;         //!< the current frame
+  int              nextFrame;            //!< the next frame in the list
+} sAnimState;
+
+//! Model Information definitions
+typedef struct
+{
+  unsigned int     numVertices;          //!< number of Vertices in the Model
+  unsigned int     numTriangles;         //!< number of triangles in the Model
+  unsigned int     numNormals;           //!< how many Normals in the Model
+  unsigned int     numTexCoor;           //!< how many Texture Coordinates in the Model
+
+  const float*     pVertices;            //!< array of the Vertives
+  sTriangleExt*    pTriangles;           //!< array of all triangles
+  const float*     pNormals;             //!< array of the Normals
+  const float*     pTexCoor;             //!< array of the Texture Coordinates
+
+} modelInfo;
+
+
+
+//! This class defines the basic components of a model
+class Model : public BaseObject {
+
+  public:
+    Model();
+    virtual ~Model();
+
+    virtual void draw() const {  }
+
+    inline const modelInfo* getModelInfo() const { return &this->pModelInfo; }
+
+    /** @returns a Pointer to the Vertex-Array, if it was deleted it returns NULL */
+    inline const float* getVertexArray() const { return this->pModelInfo.pVertices; };
+    /** @returns the VertexCount of this Model */
+    inline unsigned int getVertexCount() const { return this->pModelInfo.numVertices; };
+
+    /** @returns a Pointer to the Normals-Array, if it was deleted it returns NULL */
+    inline const float* getNormalsArray() const { return this->pModelInfo.pNormals; };
+    /** @returns the NormalsCount of this Model */
+    inline unsigned int getNormalsCount() const { return this->pModelInfo.numNormals; };
+
+    /** @returns a Pointer to the TexCoord-Array, if it was deleted it returns NULL */
+    inline const float* getTexCoordArray() const { return this->pModelInfo.pTexCoor; };
+    /** @returns the TexCoord-Count of this Model */
+    inline unsigned int getTexCoordCount() const { return this->pModelInfo.numTexCoor; };
+
+    /** @returns the Array of triangles */
+    inline sTriangleExt* getTriangles() const { return this->pModelInfo.pTriangles; };
+    /** @returns the Count of Faces of this Model */
+    inline unsigned int getFaceCount() const { return this->pModelInfo.numTriangles; };
+
+
+  protected:
+    modelInfo      pModelInfo;      //!< Reference to the modelInfo
 };
 
-
-// definition of different modes for setting up Faces
-#define VERTEX 0       //!< If Faces are created WITH Vertex-Coordinate
-#define NORMAL 1       //!< If Faces are created WITH Normals (otherwise autocalculate)
-#define TEXCOORD 2     //!< If Faces are created WITH TextureCoordinate
-
-//! an enumerator for VERTEX_FORMAT
-typedef enum VERTEX_FORMAT {
-  VERTEX_ONLY = VERTEX,
-  VERTEX_NORMAL = NORMAL,
-  VERTEX_TEXCOORD = TEXCOORD,
-  VERTEX_TEXCOORD_NORMAL = NORMAL | TEXCOORD
-};
-
-////////////////////
-/// SUB-ELEMENTS ///
-////////////////////
-//! This is the placeholder of one Vertex beloning to a Face.
-class ModelFaceElement
-{
- public:
-  ModelFaceElement();
-  ~ModelFaceElement();
-
-  int                 vertexNumber;         //!< The number of the Vertex out of the Array* vertices, this vertex points to.
-  int                 normalNumber;         //!< The number of the Normal out of the Array* normals, this vertex points to.
-  int                 texCoordNumber;       //!< The number of the textureCoordinate out of the Array* vTexture, this vertex points to.
-
-  ModelFaceElement*   next;                 //!< Point to the next FaceElement in this List.
-};
-
-//! This is the placeholder of a Face belonging to a Group of Faces.
-class ModelFace
-{
- public:
-  ModelFace();
-  ~ModelFace();
-
-  unsigned int        vertexCount;     //!< The Count of vertices this Face has.
-  ModelFaceElement*   firstElem;       //!< Points to the first Vertex (FaceElement) of this Face.
-  Material*           material;        //!< The Material to use.
-
-  ModelFace*          next;            //!< Pointer to the next Face.
-};
-
-//! Group to handle multiple Models per obj-file.
-class ModelGroup
-{
- public:
-  ModelGroup();
-  ~ModelGroup();
-
-  void cleanup();
-
-  char*        name;           //!< the Name of the Group. this is an identifier, that can be accessed via the draw (char* name) function.
-  GLubyte*     indices;        //!< The indices of the Groups. Needed for vertex-arrays
-  GLuint       listNumber;     //!< The number of the GL-List this Group gets.
-  ModelFace*   firstFace;      //!< The first Face in this group.
-  ModelFace*   currentFace;    //!< The current Face in this Group (the one we are currently working with.)
-  int          faceMode;       //!< The Mode the Face is in: initially -1, 0 for FaceList opened, 1 for Material,  3 for triangle, 4 for Quad, 5+ for Poly @todo ENUM...
-  int          faceCount;      //!< The Number of Faces this Group holds.
-
-  ModelGroup*  next;           //!< Pointer to the next Group.
-};
-
-struct ModelMaterial
-{
-  Material* material;
-  bool external;
-};
-
-/////////////
-/// MODEL ///
-/////////////
-//! Class that handles 3D-Models. it can also read them in and display them.
-class Model : public AbstractModel
-{
- public:
-  Model(const char* modelName = NULL, MODEL_TYPE type = MODEL_DISPLAY_LIST);
-  virtual ~Model();
-
-  void draw() const;
-  void draw(int groupNumber) const;
-  void draw(char* groupName) const;
-
-  void rebuild();
-
-  /** @returns Count of the Models (Groups) in this File */
-  inline int getGroupCount() const { return this->groupCount; };
-
-  /** @returns a Pointer to the Vertex-Array, if it was deleted it returns NULL */
-  inline const GLfloat* getVertexArray() const { return this->vertices->getArray(); };
-  /** @returns the VertexCount of this Model */
-  inline unsigned int getVertexCount() const { return this->vertexCount; };
-
-  /** @returns a Pointer to the Normals-Array, if it was deleted it returns NULL */
-  inline const GLfloat* getNormalsArray() const { return this->normals->getArray(); };
-  /** @returns the NormalsCount of this Model */
-  inline unsigned int getNormalsCount() const { return this->normalCount; };
-
-  /** @returns a Pointer to the TexCoord-Array, if it was deleted it returns NULL */
-  inline const GLfloat* getTexCoordArray() const { return this->vTexture->getArray(); };
-  /** @returns the TexCoord-Count of this Model */
-  inline unsigned int getTexCoordCount() const { return this->texCoordCount; };
-
-  /** @returns the Count of Faces of this Model */
-  inline unsigned int getFaceCount() const { return this->faceCount; };
-
-
-  Material* addMaterial(Material* material);
-  Material* addMaterial(const char* materialName);
-
-  bool addGroup(const char* groupString);
-  bool addVertex(const char* vertexString);
-  bool addVertex(float x, float y, float z);
-  bool addFace(const char* faceString);
-  bool addFace(int faceElemCount, VERTEX_FORMAT type, ...);
-  bool addVertexNormal(const char* normalString);
-  bool addVertexNormal(float x, float y, float z);
-  bool addVertexTexture(const char* vTextureString);
-  bool addVertexTexture(float u, float v);
-  bool setMaterial(const char* mtlString);
-  bool setMaterial(Material* mtl);
-  void finalize();
-
-
- protected:
-  void cubeModel();
-
-  Material* findMaterialByName(const char* materialName);
-
-
- protected:
-  float            scaleFactor;     //!< The Factor with which the Model should be scaled. @todo maybe one wants to scale the Model after Initialisation
-
- private:
-  bool buildVertexNormals();
-
-  bool importToDisplayList();
-  bool buildTriangleList();
-  bool addGLElement(ModelFaceElement* elem);
-
-  bool importToVertexArray();
-
-  bool deleteArrays();
-  bool cleanup();
-
- private:
-  MODEL_TYPE                 type;            //!< A type for the Model
-  bool                       finalized;       //!< Sets the Object to be finalized.
-
-  unsigned int               vertexCount;     //!< A modelwide Counter for vertices.
-  unsigned int               normalCount;     //!< A modelwide Counter for the normals.
-  unsigned int               texCoordCount;   //!< A modelwide Counter for the texCoord.
-  unsigned int               faceCount;       //!< A modelwide Counter for the faces
-  unsigned int               triangleCount;   //!< Number of triangles >= faceCount
-  tArray<GLfloat>*           vertices;        //!< The Array that handles the Vertices.
-  tArray<GLfloat>*           normals;         //!< The Array that handles the Normals.
-  tArray<GLfloat>*           vTexture;        //!< The Array that handles the VertexTextureCoordinates.
-  sTriangleExt*              triangles;       //!< The Array of triangles in the abstract_model.h style
-
-  ModelGroup*                firstGroup;      //!< The first of all groups.
-  ModelGroup*                currentGroup;    //!< The currentGroup. this is the one we will work with.
-  int                        groupCount;      //!< The Count of Groups.
-
-  std::list<ModelMaterial*>  materialList;    //!< A list for all the Materials in this Model
-};
-
-#endif
+#endif /* _MODEL_H */
Index: trunk/src/lib/graphics/importer/objModel.cc
===================================================================
--- trunk/src/lib/graphics/importer/objModel.cc	(revision 6012)
+++ trunk/src/lib/graphics/importer/objModel.cc	(revision 6022)
@@ -32,5 +32,5 @@
  * @param scaling The factor that the model will be scaled with.
 */
-OBJModel::OBJModel(const char* fileName, float scaling) : Model(fileName)
+OBJModel::OBJModel(const char* fileName, float scaling) : StaticModel(fileName)
 {
   this->objPath = "./";
Index: trunk/src/lib/graphics/importer/objModel.h
===================================================================
--- trunk/src/lib/graphics/importer/objModel.h	(revision 6012)
+++ trunk/src/lib/graphics/importer/objModel.h	(revision 6022)
@@ -7,8 +7,8 @@
 #define _OBJMODEL_H
 
-#include "model.h"
+#include "static_model.h"
 
 //! A Class, that handles the parsing of an obj-file, and inclusion as a Model.
-class OBJModel : public Model
+class OBJModel : public StaticModel
 {
  public:
Index: trunk/src/lib/graphics/importer/primitive_model.h
===================================================================
--- trunk/src/lib/graphics/importer/primitive_model.h	(revision 6012)
+++ trunk/src/lib/graphics/importer/primitive_model.h	(revision 6022)
@@ -8,5 +8,5 @@
 #define _PRIMITIVE_MODEL_H
 
-#include "model.h"
+#include "static_model.h"
 
 //! Specification of different primitives the Model knows
@@ -18,5 +18,5 @@
 
 //! A Class to create some default Models
-class PrimitiveModel : public Model {
+class PrimitiveModel : public StaticModel {
 
  public:
